package ec.edu.epn.consumosriautorizacion.Tasks;

import ec.edu.epn.consumosriautorizacion.controller.ConsultasFacturacionController;
import ec.edu.epn.consumosriautorizacion.controller.GeneracionFactOfflinePDF;
import ec.edu.epn.consumosriautorizacion.controller.GeneracionFactOfflineXML;
import ec.edu.epn.consumosriautorizacion.dto.DetallefacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.FacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.PagosDTO;
import ec.edu.epn.consumosriautorizacion.dto.UserFactDTO;
import ec.edu.epn.consumosriautorizacion.service.EmailService;
import ec.edu.epn.consumosriautorizacion.service.FTPService;
import ec.edu.epn.consumosriautorizacion.service.FileServiceImp;
import org.apache.commons.net.util.Base64;
import org.springframework.batch.core.StepContribution;
import org.springframework.batch.core.scope.context.ChunkContext;
import org.springframework.batch.core.step.tasklet.Tasklet;
import org.springframework.batch.repeat.RepeatStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static java.nio.charset.StandardCharsets.ISO_8859_1;
import static java.nio.charset.StandardCharsets.UTF_8;

@Component
public class Task_cargaDocumentacion implements Tasklet {

   /* @Autowired
    ConsultasFacturacionController consultas;


    @Autowired
    FTPService ftpService;*/



    private static String NUMEROS = "0123456789";
    private static String MAYUSCULAS = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    private static String MINUSCULAS = "abcdefghijklmnopqrstuvwxyz";
    private static String ESPECIALES = "ñÑ";

    private static String ambiente= "PRODUCCION";


    @Override
    public RepeatStatus execute(StepContribution contribution, ChunkContext chunkContext) throws Exception {


        ConsultasFacturacionController consultas= new ConsultasFacturacionController();
        FTPService ftpService= new FileServiceImp();

        List<FacturaDTO> listFact= new ArrayList<FacturaDTO>();
        /**OBTENER LA FECHA ACTUAL**/
        Date date = new Date();
        DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        listFact= consultas.consumoFactPDF(dateFormat.format(date));
        /**RECORREMOS LA LISTA DE FACTURAS PARA SU AUTORIZACION*/
        if(listFact!=null) {
            for (FacturaDTO dto : listFact) {

                List<DetallefacturaDTO> listDetalle= new ArrayList<DetallefacturaDTO>();
                List<PagosDTO> listPagos= new ArrayList<PagosDTO>();
                listDetalle= consultas.consumoDetalleFact(dto.getIdFactura());
                listPagos= consultas.consumoPagos(dto.getIdFactura());
                GeneracionFactOfflinePDF pdf= new GeneracionFactOfflinePDF();

                String attchment= pdf.generarPDFFacturaOffline(dto, listDetalle, listPagos);

                BufferedInputStream buffIn = null;
                buffIn = new BufferedInputStream(new FileInputStream(attchment));

                /**CARGAR FTP FACTURACION*/

                ftpService.uploadFileToFTP(buffIn,
                        dto.getRucCli().trim() + "_Facturas",
                        dto.getIdFactura().trim() + "-" + dto.getRucCli().trim() + ".pdf");

                /**CARGAR XML FACTURA**/
                GeneracionFactOfflineXML xmlDOc= new GeneracionFactOfflineXML();
                String attchemnXml= xmlDOc.generacionXml(dto);


                BufferedInputStream buffInXml = null;
                buffInXml = new BufferedInputStream(new FileInputStream(attchemnXml));

                ftpService.uploadFileToFTP(buffInXml,
                        dto.getRucCli().trim() + "_Facturas",
                        dto.getIdFactura().trim() + "-" + dto.getRucCli().trim() + ".xml");


                dto.setPath(dto.getRucCli().trim() + "_Facturas/" +  dto.getRucCli().trim() + ".pdf");
                dto.setPathxml(dto.getRucCli().trim() + "_Facturas/" +  dto.getRucCli().trim() + ".xml");

                consultas.actualizarPathPdf(dto);
                this.enviarCorreo(dto, attchment);




            }
        }

        return  RepeatStatus.FINISHED;
    }




    public void enviarCorreo(FacturaDTO factura, String attachment) {

        UserFactDTO userF = this.usuarioFact(factura.getRucCli().trim());


        java.util.List<String> para = new ArrayList<String>();

        if (factura.getXml() != null) {
            String mail = factura.getEmailCl();
            if(mail==null || mail.equals("")){
                mail= "german.romero@epn.edu.ec";
            }
            para.add(mail);
            String hoyFecha = "";
            DateFormat fecha = new SimpleDateFormat("yyyy/MM/dd");
            Date hoy = new Date();

            hoyFecha = fecha.format(hoy);

            String de = "<facturacion.electronica@epn.edu.ec>";
            String subject = "EPN FACTURA ELECTRÓNICA";
            // Cuerpo mensaje

            String cabecera = "<HTML><BODY>  <p align='center' style='margin-right:50px;'> <img src='https://cem.epn.edu.ec/imagenes/logos_institucionales/big_jpg/EPN_logo_big.jpg' width= '300' height='150' style='margin-right:50px;' /> <br/> <br/>";
            String cuerpo = "<p align='center' style='margin-right:50px;'>" + "<b>Estimado(a): </b> <br/>"
                    + factura.getNombreCli() + "<br/>"
                    + "<b>Una nueva Factura Electrónica está disponible para usted </b><br/>"
                    + "<b>REFERENCIAS </b> <br/>" + "<b>Factura Número: </b>  " + factura.getIdFactura() + " <br/>"
                    + "<b>Total Factura: </b>" + String.valueOf(factura.getTotalF()) + " USD <br/>"
                    + "<b>Fecha Factura: </b>" + hoyFecha + " <br/>" + "<b>Ambiente: </b>" + ambiente + " <br/>"
                    + "<b>Clave de Acceso: </b>" + factura.getClaveacceso() + " <br/>"
                    + "<b>Estado: </b>" + factura.getEstadoSri() + " <br/>"
                    + " <br/>" + "<b>Fecha Aut: </b>" + factura.getFechaautoriza()
                    + " <br/>" + "<b>Usted puede revisar este comprobante en: <br/> </b>" + "http://www.epn.edu.ec/sistema-integrado-de-informacion/facturacion-electronica/" + " <br/>"
                    + "<b>Usuario: </b>" + userF.getUsuario() + " <br/>" + "<b>Contraseña: </b>"
                    + this.remplazarCaracteresHTML(this.Desencriptar(userF.getClave())) + " <br/>"
                    + "<b>Si tiene alguna inquietud no dude en contactarnos:  </b>" + " <br/>"
                    + "<b>     asistencia.tecnica@epn.edu.ec</b>" + " <br/>"
                    + "<b>DIRECCION DE GESTION DE LA INFORMACION Y PROCESOS</b>";

            String pie = "<br/> <br/> <img src='cid:cidpie' style='margin-right:50px;'/></BODY></HTML>";



            byte[] ptext = this.remplazarCaracteresHTML(cuerpo).getBytes(ISO_8859_1);
            String cuerpoF = new String(ptext, UTF_8);

            String text = cabecera + cuerpoF + pie;

            EmailService emailService= new EmailService();
            emailService.sendEmail(para, subject, text, attachment, factura.getIdFactura());
        }
    }



    public String generaClaves(String key, int length) {
        String pswd = "";
        length = 5;
        for (int i = 0; i < length; i++) {
            pswd += (key.charAt((int) (Math.random() * key.length())));
            System.out.println("PSW 1: " + pswd.toString());

        }
        return pswd;
    }


    public String encriptar(String input) {
        byte[] crypted = null;
        String key = "1357908642135790";

        try {
            SecretKeySpec skey = new SecretKeySpec(key.getBytes(), "AES");
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, skey);
            byte[] plainTextBytes = input.getBytes("utf-8");
            crypted = cipher.doFinal(plainTextBytes);

        } catch (Exception e) {
            System.out.println(e.toString());
        }
        return new String(Base64.encodeBase64(crypted));
    }



    public UserFactDTO usuarioFact(String ciRucCli) {

        ConsultasFacturacionController consultas= new ConsultasFacturacionController();
        UserFactDTO usuario= new UserFactDTO();
                usuario = consultas.consumoUserFact(ciRucCli.trim());
        try {
            if (usuario != null) {
                if (usuario.getClave().trim().equals("")){
                    usuario.setClave(this.encriptar(this.generaClaves(NUMEROS + MAYUSCULAS + MINUSCULAS + ESPECIALES, 12)));
                    consultas.actualizarUserFact(usuario);
                }
                return usuario;

            } else {
                usuario = new UserFactDTO();
                usuario.setUsuario(ciRucCli.trim());
                usuario.setClave(this.encriptar(this.generaClaves(NUMEROS + MAYUSCULAS + MINUSCULAS + ESPECIALES, 12)));
                consultas.ingresarUserFact(usuario);
                return usuario;
            }
        } catch (Exception e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
            return null;
        }

    }

    public static String Desencriptar(String input) {
        byte[] output = null;


        String key = "1357908642135790";
        String base64EncryptedString = "";
        try {
            SecretKeySpec skey = new SecretKeySpec(key.getBytes(), "AES");
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, skey);
            byte[] plainTextBytes = input.getBytes("utf-8");
            output = cipher.doFinal(Base64.decodeBase64(plainTextBytes));
            base64EncryptedString = new String(output, "UTF-8");
        } catch (Exception e) {
            System.out.println(e.toString());
        }
        return new String(base64EncryptedString);
    }


    public String remplazarCaracteresHTML(String valor){
        try {
            String A= "&#193;";
            String E= "&#201;";
            String I= "&#205;";
            String O= "&#211;";
            String U= "&#218;";
            String a= "&#225;";
            String e= "&#233;";
            String i= "&#237;";
            String o= "&#243;";
            String u= "&#250;";
            String Ñ= "&#209;";
            String ñ= "&#241;";

            valor= valor.replace("á", a).replace("é", e).replace("í", i).replace("ó", o).replace("ú", u).replace("Á", A).replace("É", E);
            valor= valor.replace("Í", I).replace("Ó", O).replace("Ú", U).replace("Ñ", Ñ).replace("ñ", ñ);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return valor;
    }


}
