package ec.edu.epn.consumosriautorizacion.controller;


import ec.edu.epn.consumosriautorizacion.dto.RequestJob;
import ec.edu.epn.consumosriautorizacion.service.TaskDefinitionBean;
import ec.edu.epn.consumosriautorizacion.service.TaskSchedulingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;


@RestController
@RequestMapping("/batch")
public class JobController {

    @Autowired
    private TaskSchedulingService taskSchedulingService;

    @Autowired
    private TaskDefinitionBean taskDefinitionBean;


    @PostMapping("/inciarCron")
    public String iniciar(@RequestBody RequestJob taskDefinition) {

        taskDefinitionBean.setTaskDefinition(taskDefinition);
        return taskSchedulingService.scheduleATask(taskDefinitionBean, taskDefinition.getCronExpression());
    }

    @PostMapping(path = "/stopCron/{jobid}")
    public String removeJob(@PathVariable String jobid) {
        taskSchedulingService.removeScheduledTask(jobid);
        return "TAREA " + jobid + " DETENIDA";
    }

    @PostMapping("/stopJob")
    public String startBatch() {
        taskSchedulingService.removeAllScheduledTask();
        return "CRON-JOB DETENIDO";
    }

    @GetMapping("/allJobs")
    public ResponseEntity<?> getAllJObs() {
        return new ResponseEntity<>(taskSchedulingService.getAllJobs(), HttpStatus.OK);
    }

}
