package ec.edu.epn.consumosriautorizacion.controller;


import ec.edu.epn.consumosriautorizacion.Tasks.Task_autorizacion;
import ec.edu.epn.consumosriautorizacion.Tasks.Task_cargaDocumentacion;
import ec.edu.epn.consumosriautorizacion.dto.DetallefacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.FacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.FacturacionOfflineDTO;
import ec.edu.epn.consumosriautorizacion.dto.PagosDTO;
import ec.edu.epn.consumosriautorizacion.exceptions.FTPErrors;
import ec.edu.epn.consumosriautorizacion.service.EmailService;
import ec.edu.epn.consumosriautorizacion.service.FTPService;
import ec.gob.sri.comprobantes.ws.RecepcionComprobantesOffline;
import ec.gob.sri.comprobantes.ws.RecepcionComprobantesOfflineService;
import ec.gob.sri.comprobantes.ws.aut.AutorizacionComprobantesOffline;
import ec.gob.sri.comprobantes.ws.aut.AutorizacionComprobantesOfflineService;
import ec.gob.sri.comprobantes.ws.aut.RespuestaComprobante;
import ec.gob.sri.comprobantes.ws.RespuestaSolicitud;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.net.URL;
import javax.xml.namespace.QName;

import org.springframework.batch.repeat.RepeatStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;

import static java.nio.charset.StandardCharsets.ISO_8859_1;
import static java.nio.charset.StandardCharsets.UTF_8;

@RestController
public class SriAutorizacionController {


	@Autowired
	ConsultasFacturacionController consultas;


	@Autowired
	FTPService ftpService;

	@GetMapping("/pruebas")
	public String pruebas() throws FTPErrors, FileNotFoundException {



		return "PRUEBA EXITOSA";
	}





	@GetMapping("/autorizacion/{numAutorizacion}")
	public FacturacionOfflineDTO autorizaciona(@PathVariable String numAutorizacion){
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();

		try {

			String wsdl = "https://cel.sri.gob.ec/comprobantes-electronicos-ws/AutorizacionComprobantesOffline?wsdl";
			URL url = new URL(wsdl);
			QName qname = new QName("http://ec.gob.sri.ws.autorizacion", "AutorizacionComprobantesOfflineService");
			AutorizacionComprobantesOfflineService services = new AutorizacionComprobantesOfflineService(new URL(wsdl), qname);
			AutorizacionComprobantesOffline port = services.getAutorizacionComprobantesOfflinePort();


			RespuestaComprobante respuesta = port.autorizacionComprobante(numAutorizacion);

			if(respuesta.getAutorizaciones()!=null){

				if(respuesta.getAutorizaciones().getAutorizacion().get(0).getEstado().equals("AUTORIZADO")){
					offlineDTO.setAmbiente("PRODUCCION");
					offlineDTO.setEstado("AUTORIZADO");

					try {
						respuesta.getAutorizaciones().getAutorizacion().get(0).getFechaAutorizacion().toGregorianCalendar().setTimeZone(TimeZone.getTimeZone("ECT"));
						offlineDTO.setFechaAutorizacion(Timestamp.valueOf(respuesta.getAutorizaciones().getAutorizacion().get(0).getFechaAutorizacion().toGregorianCalendar().getTimeZone().toString()));
					} catch (Exception e) {

						Calendar cal = Calendar.getInstance();
						Date fechaHoy= cal.getTime();
						String DATE_FORMAT = "yyyy-MM-dd hh:mm:ss";
						TimeZone timeZone = TimeZone.getTimeZone("ECT");
						SimpleDateFormat formatterWithTimeZone = new SimpleDateFormat(DATE_FORMAT);
						formatterWithTimeZone.setTimeZone(timeZone);
						String sDate = formatterWithTimeZone.format(fechaHoy);
						SimpleDateFormat formatter = new SimpleDateFormat(DATE_FORMAT);
						Date dateWithTimeZone = formatter.parse(sDate);




						offlineDTO.setFechaAutorizacion(new Timestamp(dateWithTimeZone.getTime()));
					}

				}

				if(!respuesta.getAutorizaciones().getAutorizacion().get(0).getEstado().equals("AUTORIZADO")){

					offlineDTO.setAmbiente("PRODUCCION");
					offlineDTO.setEstado("NO AUTORIZADO -ND");
					try {
						offlineDTO.setMensaje(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getMensaje());
					} catch (Exception e) {
						offlineDTO.setMensaje("NO DEFIIDO");
					}


					try {
						offlineDTO.setIdentificador(Integer.valueOf(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getIdentificador()));
					} catch (Exception e) {
						offlineDTO.setIdentificador(0);
					}


					try {
						offlineDTO.setTipo(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getTipo());
					} catch (Exception e) {
						offlineDTO.setTipo("NO DEFINIDO");
					}

					try {
						offlineDTO.setInfoAdicional(respuesta.getAutorizaciones().getAutorizacion().get(0).getMensajes().getMensaje().get(0).getInformacionAdicional());
					} catch (Exception e) {
						offlineDTO.setInfoAdicional("NINGNUNO");
					}
				}
			}

			if(respuesta.getNumeroComprobantes().equals("0")){
				offlineDTO.setAmbiente("PRODUCCION");
				offlineDTO.setEstado("NO AUTORIZADO SIN ENVIO RECEPCION");
				offlineDTO.setMensaje("NO DEFIIDO");
				offlineDTO.setTipo("NO DEFINIDO");
				offlineDTO.setInfoAdicional("NINGNUNO");
			}

			return offlineDTO;

		} catch (Exception e) {
			FacturacionOfflineDTO offlineDTOerror = new FacturacionOfflineDTO();

			offlineDTOerror.setMensaje(e.getMessage());
			return offlineDTOerror;
		}
	}

	@GetMapping("/envioCorreo/{correo}")
	public FacturacionOfflineDTO envioCorreo(@PathVariable String correo) {
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();

		try {

			java.util.List<String> para = new ArrayList<String>();



			para.add(correo);
			String hoyFecha = "";
			DateFormat fecha = new SimpleDateFormat("yyyy/MM/dd");
			Date hoy = new Date();

			hoyFecha = fecha.format(hoy);

			String de = "<facturacion.electronica@epn.edu.ec>";
			String subject = "EPN FACTURA ELECTRÓNICA";
			// Cuerpo mensaje

			String cabecera = "<HTML><BODY>  <p align='center' style='margin-right:50px;'> <img src='https://cem.epn.edu.ec/imagenes/logos_institucionales/big_jpg/EPN_logo_big.jpg' width= '300' height='150' style='margin-right:50px;' /> <br/> <br/>";
			String cuerpo = "<p align='center' style='margin-right:50px;'>" + "<b>Estimado(a): </b> <br/>"
					+ "GERMAN ROMERO" + "<br/>"
					+ "<b>Una nueva Factura Electrónica está disponible para usted  </b><br/>"
					+ "<b>REFERENCIAS </b> <br/>" + "<b>Factura Número: </b>  001-001-000001 <br/>"
					+ "<b>Total Factura: </b> 50 USD <br/>"
					+ "<b>Fecha Factura: </b>" + hoyFecha + " <br/>" + "<b>Ambiente: </b> PRODUCCION <br/>"
					+ "<b>Estado: </b> PRUEBAS <br/>" + "<b>Clave de Acceso: </b>"
					+  " <br/>";

			String pie = "<br/> <br/> <img src='cid:cidpie' style='margin-right:50px;'/></BODY></HTML>";



			EmailService emailService= new EmailService();

			byte[] ptext =  emailService.remplazarCaracteresHTML(cuerpo).getBytes(ISO_8859_1);
			String cuerpoF = new String(ptext, UTF_8);

			String text = cabecera + cuerpoF + pie;

			java.util.List<String> adjuntos = new ArrayList<String>();


		//	ConsultasFacturacionController consulta= new ConsultasFacturacionController();
			FacturaDTO facturaDTO= new FacturaDTO();
			List<DetallefacturaDTO> listDetalle= new ArrayList<DetallefacturaDTO>();
			List<PagosDTO> listPagos= new ArrayList<PagosDTO>();
			facturaDTO= consultas.consumoFactura("001-003-0077105");
			listDetalle= consultas.consumoDetalleFact(facturaDTO.getIdFactura());
			listPagos= consultas.consumoPagos(facturaDTO.getIdFactura());
			GeneracionFactOfflinePDF pdf= new GeneracionFactOfflinePDF();

			String attchment= pdf.generarPDFFacturaOffline(facturaDTO, listDetalle, listPagos);




			//emailService.sendEmail(para, subject, text, attchment);

			offlineDTO.setMensaje("CORREO ENVIADO CORRECTAMENTE");
			return offlineDTO;

		}catch (Exception e){

			FacturacionOfflineDTO offlineDTOerror = new FacturacionOfflineDTO();

			offlineDTOerror.setMensaje(e.getMessage());
			return offlineDTOerror;

		}
	}


	@GetMapping("/autorizar/{fecha}")
	public FacturacionOfflineDTO autorizar(@PathVariable String fecha) {
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();
		List<FacturaDTO> listFactContingencia= new ArrayList<FacturaDTO>();
		FacturacionOfflineDTO offlineDTOerror = new FacturacionOfflineDTO();
		try {

		/**OBTENER LA FECHA ACTUAL**/
		Date date = new Date();
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		//listFactContingencia= consultas.consumoFactContingencia(dateFormat.format(date));
			listFactContingencia= consultas.consumoFactContingencia(fecha);
		/**RECORREMOS LA LISTA DE FACTURAS PARA SU AUTORIZACION*/
		if(listFactContingencia!=null){
			offlineDTO.setMensaje("AUTORIZACIONES CORRECTAMENTE REALIZADAS " + listFactContingencia.size());
			for(FacturaDTO dto: listFactContingencia){

				Task_autorizacion tarea= new Task_autorizacion();

				/**ENVIO PARA RECEPCION DE FACTURAS**/
				FacturacionOfflineDTO offlineRecepcionDTO = new FacturacionOfflineDTO();
				offlineRecepcionDTO= tarea.recepcion(dto.getXml());

				if(offlineRecepcionDTO.getEstado().equals("RECIBIDA")){

					tarea.envioCorreoRecepcion(dto);

					dto.setEstadoFactura(offlineRecepcionDTO.getEstado());

					try {
						consultas.actualizarEstadoSRIFact(dto);
					}catch(Exception e){

						offlineDTOerror.setMensaje(e.getMessage());
						return offlineDTOerror;
					}

					/**ENVIO PARA AUTORIZACIÓN DE FACTURA**/
					FacturacionOfflineDTO offlineAutorizacionDTO = new FacturacionOfflineDTO();

					offlineAutorizacionDTO= tarea.autorizacion(dto.getNumautoriza());

					if(offlineAutorizacionDTO!=null){

						if(offlineAutorizacionDTO.getEstado().equals("AUTORIZADO")){
							dto.setFechaautoriza(offlineAutorizacionDTO.getFechaAutorizacion().toString());
							dto.setEstadoFactura(offlineAutorizacionDTO.getEstado());


							try {
								consultas.actualizarSRIFact(dto);
							}catch(Exception e){
								offlineDTOerror.setMensaje(e.getMessage());
								return offlineDTOerror;
							}

						}else{
							offlineAutorizacionDTO.setNumeroAutoFac(dto.getIdFactura());
							consultas.ingresoErrorSRIFact(offlineAutorizacionDTO);
						}

					}
				}else{

					offlineRecepcionDTO.setNumeroAutoFac(dto.getIdFactura());
					consultas.ingresoErrorSRIFact(offlineRecepcionDTO);

				}

			}
		}else{
			offlineDTO.setMensaje("AUTORIZACIONES CORRECTAMENTE REALIZADAS 0");
		}

			return offlineDTO;


		} catch (Exception e) {

			offlineDTOerror.setMensaje(e.getMessage());
			return offlineDTOerror;

		}

	}




	@GetMapping("/generardoc/{fecha}")
	public FacturacionOfflineDTO generaddoc(@PathVariable String fecha) {
		FacturacionOfflineDTO offlineDTO = new FacturacionOfflineDTO();
		List<FacturaDTO> listFact= new ArrayList<FacturaDTO>();
		FacturacionOfflineDTO offlineDTOerror = new FacturacionOfflineDTO();

		try {
			/**OBTENER LA FECHA ACTUAL**/
			Date date = new Date();
			DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
			//listFact= consultas.consumoFactContingencia(dateFormat.format(date));
			listFact= consultas.consumoFactPDF(fecha);
			/**RECORREMOS LA LISTA DE FACTURAS PARA SU AUTORIZACION*/
			if(listFact!=null) {
				for (FacturaDTO dto : listFact) {

					Task_cargaDocumentacion tarea= new Task_cargaDocumentacion();

					List<DetallefacturaDTO> listDetalle= new ArrayList<DetallefacturaDTO>();
					List<PagosDTO> listPagos= new ArrayList<PagosDTO>();
					listDetalle= consultas.consumoDetalleFact(dto.getIdFactura());
					listPagos= consultas.consumoPagos(dto.getIdFactura());
					GeneracionFactOfflinePDF pdf= new GeneracionFactOfflinePDF();

					String attchment= pdf.generarPDFFacturaOffline(dto, listDetalle, listPagos);

					BufferedInputStream buffIn = null;
					buffIn = new BufferedInputStream(new FileInputStream(attchment));

					/**CARGAR FTP FACTURACION*/

					ftpService.uploadFileToFTP(buffIn,
							dto.getRucCli().trim() + "_Facturas",
							dto.getIdFactura().trim() + "-" + dto.getRucCli().trim() + ".pdf");

					/**CARGAR XML FACTURA**/
					GeneracionFactOfflineXML xmlDOc= new GeneracionFactOfflineXML();
					String attchemnXml= xmlDOc.generacionXml(dto);


					BufferedInputStream buffInXml = null;
					buffInXml = new BufferedInputStream(new FileInputStream(attchemnXml));

					ftpService.uploadFileToFTP(buffInXml,
							dto.getRucCli().trim() + "_Facturas",
							dto.getIdFactura().trim() + "-" + dto.getRucCli().trim() + ".xml");


					dto.setPath(dto.getRucCli().trim() + "_Facturas/" +  dto.getIdFactura().trim() + "-" + dto.getRucCli().trim() + ".pdf");
					dto.setPathxml(dto.getRucCli().trim() + "_Facturas/" + dto.getIdFactura().trim() + "-" + dto.getRucCli().trim() + ".xml");

					consultas.actualizarPathPdf(dto);
					tarea.enviarCorreo(dto, attchment);




				}
			}



			offlineDTO.setMensaje("DOCUMENTOS GENERADOS CORRECTAMENTE");
			return offlineDTO;

		}catch (Exception e){
			offlineDTOerror.setMensaje(e.getMessage());
			return offlineDTOerror;
		}
	}



}
