package ec.edu.epn.consumosriautorizacion.service;

import ec.edu.epn.consumosriautorizacion.dto.RequestJob;
import org.springframework.batch.core.*;
import org.springframework.batch.core.launch.JobLauncher;
import org.springframework.batch.core.repository.JobExecutionAlreadyRunningException;
import org.springframework.batch.core.repository.JobInstanceAlreadyCompleteException;
import org.springframework.batch.core.repository.JobRestartException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class TaskDefinitionBean implements Runnable {

    private RequestJob taskDefinition;
    @Autowired
    private JobLauncher jobLauncher;

    public JobExecution jobExecution;

    @Autowired
    private Job job;

    @Override
    public void run() {
        System.out.println("Ejecutando Accion: " + taskDefinition.getActionType());
        System.out.println("Info Adicional: " + taskDefinition.getData());
        JobParameters jobParameters = new JobParametersBuilder()
                .addLong("time", System.currentTimeMillis())
                .addString("info", "Batch EN CRON")
                .toJobParameters();
        try {
            jobExecution = jobLauncher.run(job, jobParameters);
        } catch (JobExecutionAlreadyRunningException e) {
            throw new RuntimeException(e);
        } catch (JobRestartException e) {
            throw new RuntimeException(e);
        } catch (JobInstanceAlreadyCompleteException e) {
            throw new RuntimeException(e);
        } catch (JobParametersInvalidException e) {
            throw new RuntimeException(e);
        }
    }

    public RequestJob getTaskDefinition() {
        return taskDefinition;
    }

    public void setTaskDefinition(RequestJob taskDefinition) {
        this.taskDefinition = taskDefinition;
    }
}
