package ec.edu.epn.consumosriautorizacion.service;

import org.springframework.batch.core.BatchStatus;
import org.springframework.batch.core.JobExecution;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.TaskScheduler;
import org.springframework.scheduling.support.CronTrigger;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.concurrent.ScheduledFuture;

@Service
public class TaskSchedulingService {

    @Autowired
    private TaskScheduler taskScheduler;

    Map<String, ScheduledFuture<?>> jobsMap = new HashMap<>();

    public String scheduleATask(Runnable tasklet, String cronExpression) {
        UUID uuid = UUID.randomUUID();
        String jobId = uuid.toString();
        System.out.println("Cron con job id: " + jobId + " y cron : " + cronExpression);
        //ScheduledFuture<?> scheduledTask = taskScheduler.schedule(tasklet, new CronTrigger(cronExpression, TimeZone.getTimeZone(TimeZone.getDefault().getID())));
        ScheduledFuture<?> scheduledTask = taskScheduler.schedule(tasklet, new CronTrigger("0 0/5 8,9,10,11,12,13,14,15,16,17,18 * * ?"));
        jobsMap.put(jobId, scheduledTask);
        return "CRON-JOB:{id: " + jobId + ", cron : " + cronExpression + "}";
    }

    public void removeScheduledTask(String jobId) {
        ScheduledFuture<?> scheduledTask = jobsMap.get(jobId);
        if (scheduledTask != null) {
            scheduledTask.cancel(true);
            jobsMap.put(jobId, null);
        }
    }

    public void removeAllScheduledTask() {
        for (Map.Entry<String, ScheduledFuture<?>> entry : jobsMap.entrySet()) {
            ScheduledFuture<?> scheduledTask = entry.getValue();
            if (scheduledTask != null) {
                scheduledTask.cancel(true);
                jobsMap.put(entry.getKey(), null);
            }
        }
    }

    public Map<String, ScheduledFuture<?>> getAllJobs() {
        return jobsMap;
    }

    public String detenerJob(JobExecution jobExecution) {
        if (jobExecution != null) {
            jobExecution.stop();
            return "Proceso batch detenido";
        } else {
            return "No hay proceso batch en ejecución";
        }
    }

    public String pauseJob(JobExecution jobExecution) {
        if (jobExecution != null) {
            jobExecution.setStatus(BatchStatus.STOPPING);
            return "Proceso batch pausado";
        } else {
            return "No hay proceso batch en ejecución";
        }
    }
}
